<template>
  <div class="users">
  <Alert/>
    <h3>These are All Users</h3>
  <br>
    <table border=1>
    <th> Username </th>
    <th> Full Name </th>
    <th> Email </th>
    <th> Followings </th>
    <th> Followers </th>
    <th> Action </th>
    <tr v-for="usero in users" :key="usero.id">
    <td> @{{usero.username}}</td>
    <td> {{usero.name}}</td>
    <td> {{usero.email}}</td>
    <td> {{usero.followers}}</td>
    <td> {{usero.followings}}</td>
    <div v-if="usero.id !== user.id">
    <td> <v-btn
        small text
        class="blue--text"
        @click="follow(usero.id)"
      >
        Follow
      </v-btn>
    </td>
    </div>
    <div v-else>
    <td> <v-btn
        small text
        class="red--text"
      >
        This is You
      </v-btn>
    </td>
    </div>
    </tr>
    </table>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';

export default {
    data : () => ({
      users : [],
      apiDomain : "http://127.0.0.1:8000",
    }),

    components: { 
    Alert : () => import ('../components/Alert.vue'),
    },

    computed: {
    ...mapGetters({
      guest : 'auth/guest',
      user : 'auth/user',
      token : 'auth/token'
    }),
    },


    methods : {
      ...mapActions({
        setAlert  : 'alert/set',
        setToken : 'auth/setToken',
        setUser : 'auth/setUser',
      }),
      follow:  function (folId) {
          const config = {
              method: "post",
              url: this.apiDomain + "/api/followers",
              headers: {
                'Authorization' : 'Bearer ' + this.token,
              },
              data: {
              'follower_id' : folId
              }
          }

          this.axios(config)
              .then((response) => {
                  this.getUsers()
                  console.log(response.data.data)
                  this.setAlert({
                    status : true,
                    color  : 'success',
                    text  : 'You followed that user',
                })
              })
              .catch((error) => {
                  console.log(error)
              })
      },

      getUsers: function () {
          const config = {
              method: "get",
              url: this.apiDomain + "/api/all_users"
          }

          this.axios(config)
              .then((response) => {
                  this.users = response.data.data
                  console.log(response.data.data)
              })
              .catch((error) => {
                  console.log(error)
              })
      },
    },
    created(){
    this.getUsers();
    }
}
</script>
